#include"block.hpp"
#include"space.hpp"
#include"superspace.hpp"




void
Block::
move()
{
    if(bubble_timer)
    {
      --bubble_timer;

        if(!(bubble_timer>>1))
        {
          auto  top = space->get_link(Dir::top);

            if(top && top->get_block())
            {
              top->get_block()->unset_flag(landing_flag);
            }


          set_flag(deleteme_flag);
        }
    }


    if(test_flag(automove_flag))
    {
        if(!test_flag(float_flag))
        {
          space->start_move_block(movement_dir);
        }
    }


    if(test_flag(busy_flag))
    {
        if(timer)
        {
          --timer;
        }


        if(!timer)
        {
          timer = timer_base;

            if(pc < functions.size())
            {
              functions[pc++](*this);
            }


            if(pc >= functions.size())
            {
              unset_flag(busy_flag);

              moving_counter = 0;
            }
        }
    }


    if(test_flag(landing_flag))
    {
      auto  bottom = space->get_link(Dir::bottom);

        if(bottom && !bottom->get_block())
        {
          unset_flag(landing_flag);
        }
    }

  else
    {
        if(!moving_counter)
        {
          auto  bottom = space->get_link(Dir::bottom);

            if(!bottom || bottom->get_block())
            {
              set_flag(landing_flag);

                if((this != superspace.get_superblock()) && !bubble_timer)
                {
                  set_flag(eraseme_flag);
                }
            }


            if(!test_flag(landing_flag) && (this != superspace.get_superblock()) && check_around_float())
            {
              set_flag(float_flag);
            }
        }
    }
}




bool
Block::
check_around_float() const
{
  auto   left = space->get_link(Dir::left );
  auto  right = space->get_link(Dir::right);
  auto   back = space->get_link(Dir::back );
  auto  front = space->get_link(Dir::front);

  return((left  &&  left->get_block() &&  left->get_block()->test_flag(float_flag)) ||
         (right && right->get_block() && right->get_block()->test_flag(float_flag)) ||
         (back  &&  back->get_block() &&  back->get_block()->test_flag(float_flag)) ||
         (front && front->get_block() && front->get_block()->test_flag(float_flag)));
}




void
Block::
move_left()
{
  coord.x -= superspace.get_move_speed();

    if(this == superspace.get_superblock())
    {
      auto&  view_rect = superspace.get_view_rect();

      int  pos = (view_rect.x+(view_rect.x_width>>2));

        if(coord.x < pos)
        {
          superspace.move_view_left(superspace.get_move_speed());
        }
    }
}


void
Block::
move_right()
{
  coord.x += superspace.get_move_speed();

    if(this == superspace.get_superblock())
    {
      auto&  view_rect = superspace.get_view_rect();

      int  pos = (view_rect.x+(view_rect.x_width>>2));

        if(coord.x >= pos)
        {
          superspace.move_view_right(superspace.get_move_speed());
        }
    }
}


void
Block::
move_front()
{
  coord.y += superspace.get_move_speed();

    if(this == superspace.get_superblock())
    {
      auto&  view_rect = superspace.get_view_rect();

      int  pos = (view_rect.y+(view_rect.y_width>>2));

        if(coord.y >= pos)
        {
          superspace.move_view_front(superspace.get_move_speed());
        }
    }
}


void
Block::
move_back()
{
  coord.y -= superspace.get_move_speed();

    if(this == superspace.get_superblock())
    {
      auto&  view_rect = superspace.get_view_rect();

      int  pos = (view_rect.y+(view_rect.y_width>>2));

        if(coord.y < pos)
        {
          superspace.move_view_back(superspace.get_move_speed());
        }
    }
}


void
Block::
move_top()
{
  coord.z += (superspace.get_move_speed()>>1);

    if(this == superspace.get_superblock())
    {
      auto&  view_rect = superspace.get_view_rect();

      int  pos = (view_rect.z+(view_rect.height>>3));

        if(coord.z >= pos)
        {
          superspace.move_view_top(superspace.get_move_speed()>>1);
        }
    }
}


void
Block::
move_bottom()
{
  coord.z -= superspace.get_move_speed();

    if(this == superspace.get_superblock())
    {
      auto&  view_rect = superspace.get_view_rect();

      int  pos = (view_rect.z+(view_rect.height>>3));

        if(coord.z < pos)
        {
          superspace.move_view_bottom(superspace.get_move_speed());
        }
    }
}




