#include"canvas.hpp"
#include"font.hpp"




int
Canvas::Drawer::
draw_ascii(char  c, uint32_t  color, int  x, int  y)
{
  auto  p = ascii::get_data(c);

  x += 2;

    rep(yy,font_h)
    {
      auto  code = *p++;

      auto  p = get(x,y+yy);

        rep(xx,font_w/2)
        {
            if(code&0x80)
            {
              *p.ptr32 = color;
            }


            code <<= 1;
          p.ptr32 += 1;
        }
    }


   return font_w/2;
}


int
Canvas::Drawer::
draw_unicode(char16_t  c, uint32_t  color, int  x, int  y)
{
  auto  p = unicode::get_data(c);

    if(p)
    {
      x += 2;

        rep(yy,font_h)
        {
          uint16_t  code = *p++;

          auto  p = get(x,y+yy);

            rep(xx,font_w)
            {
                if(code&0x8000)
                {
                  *p.ptr32 = color;
                }


                code <<= 1;
              p.ptr32 += 1;
            }
        }


      return font_w;
    }


  return 0;
}




void
Canvas::Drawer::
draw_ascii(const char*  s, uint32_t  color, int  x, int  y)
{
  draw_unicode(to_u16string(s).data(),color,x,y);
}


void
Canvas::Drawer::
draw_utf8(const char*  s, uint32_t  color, int  x, int  y)
{
    for(;;)
    {
      auto  c = get_unicode(s);

        if(!c)
        {
          break;
        }


      x += ((c <= 0xFF)?   draw_ascii(c,color,x,y)
                       : draw_unicode(c,color,x,y));
    }
}


void
Canvas::Drawer::
draw_unicode(const char16_t*  s, uint32_t  color, int  x, int  y)
{
    while(*s)
    {
      auto  c = *s++;

      x += ((c <= 0xFF)?   draw_ascii(c,color,x,y)
                       : draw_unicode(c,color,x,y));
    }
}




void
Canvas::Drawer::
draw_formatted_ascii(uint32_t  color, int  x, int  y, const char*  fmt, ...)
{
  char  buf[256];

  va_list  ap;
  va_start(ap,fmt);

  vsnprintf(buf,sizeof(buf),fmt,ap);

  va_end(ap);

  draw_ascii(buf,color,x,y);
}


void
Canvas::Drawer::
draw_formatted_utf8( uint32_t  color, int  x, int  y, const char*  fmt, ...)
{
  char  buf[256];

  va_list  ap;
  va_start(ap,fmt);

  vsnprintf(buf,sizeof(buf),fmt,ap);

  va_end(ap);

  draw_utf8(buf,color,x,y);
}





