#include"chipmap.hpp"




ChipMap::
ChipMap(int  _chip_w, int  _chip_h, int  _table_w, int  _table_h):
chip_w(_chip_w),
chip_h(_chip_h),
table_w(_table_w),
table_h(_table_h),
table(table_w*table_h),
chip_number(0)
{
}




int
ChipMap::
push_back(const uint32_t*  colors)
{
  int  n = chip_w*chip_h;

    while(n--)
    {
      chips.push_back(*colors++);
    }


  return chip_number++;
}


uint32_t*
ChipMap::
get_chip(int  i)
{
  return &chips[(chip_w*chip_h)*i];
}


const uint32_t*
ChipMap::
get_chip(int  i) const
{
  return &chips[(chip_w*chip_h)*i];
}


int
ChipMap::
get_index(int  x, int  y) const
{
  return table[(table_w*y)+x];
}


void
ChipMap::
set_index(int  i, int  x, int  y)
{
  table[(table_w*y)+x] = i;
}




