#ifndef IRECO_HPP
#define IRECO_HPP


#include"util.hpp"
#include<cerrno>




struct
IrecoResult
{
  std::vector<std::string>  strings;

  IrecoResult(                  );
  IrecoResult(IrecoResult&&  rhs);

  std::string&  operator[](int  i);

  void  print() const;

};


struct
Ireco
{
public:
  std::string   name;
  std::string  value;

  std::vector<Ireco>  children;

  Ireco(            );
  Ireco(Ireco&&  rhs);


  const Ireco*  operator[](const char*  name) const;

  operator  bool() const;

  const std::string*  operator->() const;

  std::vector<const Ireco*>  collect(const std::string&  name) const;

  IrecoResult  split() const;

  void  print(int  indent) const;

};


Ireco  load_ireco(const char*  path);




#endif




