#include"block.hpp"
#include"space.hpp"
#include"superspace.hpp"
#include"canvas.hpp"




namespace{


void
put_vline(uint32_t*  dst, int  width, uint32_t  color, int  x, int  y, int  len)
{
  dst += ((width*y)+x);

    while(len--)
    {
      *dst = color;

      dst += width;
    }
}


}


void
fill_lt(uint32_t*  dst, int  width, int  side_length, const uint8_t*  rgba, int  x, int  y)
{
  auto  rgba8888 = make_rgba8888(rgba[0],rgba[1],rgba[2],rgba[3]);

  put_vline(dst,width,rgba8888,x,y,side_length);

  int  h = side_length;

    rep(n,(side_length/2))
    {
      x -= 1;
      y += 1;
      h -= 2;

      put_vline(dst,width,rgba8888,  x,y,h);
      put_vline(dst,width,rgba8888,--x,y,h);
    }
}


void
fill_gt(uint32_t*  dst, int  width, int  side_length, const uint8_t*  rgba, int  x, int  y)
{
  auto  rgba8888 = make_rgba8888(rgba[0],rgba[1],rgba[2],rgba[3]);

  put_vline(dst,width,rgba8888,x,y,side_length);

  int  h = side_length;

    rep(n,(side_length/2))
    {
      x += 1;
      y += 1;
      h -= 2;

      put_vline(dst,width,rgba8888,  x,y,h);
      put_vline(dst,width,rgba8888,++x,y,h);
    }
}




