#include"block.hpp"
#include"space.hpp"
#include"superspace.hpp"




Space::
Space(SuperSpace&  spsp, int  _x, int  _y, int  _z):
superspace(spsp),
coord(_x,_y,_z)
{
  block = nullptr;

    for(auto&  ln: links)
    {
      ln = nullptr;
    }
}




Space*
Space::
get_link(Dir  dir)
{
  return links[(int)dir];
}


void
Space::
set_link(Dir  dir, Space*  sp)
{
  links[(int)dir] = sp;
}


      Block*  Space::get_block()      {return block;}
const Block*  Space::get_block() const{return block;}


void
Space::
set_block(Block*  blk)
{
  block = blk;
}


void
Space::
wake_upper()
{
  auto  upper = links[(int)Dir::top];

    while(upper && upper->get_block())
    {
      superspace.insert_block(upper->get_block());

      upper = upper->links[(int)Dir::top];
    }
}




namespace{


void    left_fn(Block&  that){if(that.decrease_moving_counter()){that.move_left()  ;  that.jump_relatively(-1);}}
void   right_fn(Block&  that){if(that.decrease_moving_counter()){that.move_right() ;  that.jump_relatively(-1);}}
void   front_fn(Block&  that){if(that.decrease_moving_counter()){that.move_front() ;  that.jump_relatively(-1);}}
void    back_fn(Block&  that){if(that.decrease_moving_counter()){that.move_back()  ;  that.jump_relatively(-1);}}
void     top_fn(Block&  that){if(that.decrease_moving_counter()){that.move_top()   ;  that.jump_relatively(-1);}}
void  bottom_fn(Block&  that){if(that.decrease_moving_counter()){that.move_bottom();  that.jump_relatively(-1);}}

}


bool
Space::
start_move_block(Dir  dir_id, int  pushing_power)
{
    if(!block || block->test_flag(Block::busy_flag))
    {
      return false;
    } 


  auto  dst_space = links[(int)dir_id];

    if(!dst_space)
    {
      return false;
    }


    if(dst_space->get_block())
    {
        if((dir_id == Dir::top) || (dir_id == Dir::bottom))
        {
          return false;
        }


        if((pushing_power > 0) && dst_space->start_move_block(dir_id,pushing_power-1))
        {
        }

      else
        {
          return false;
        }
    }


  dst_space->set_block(block)                     ;
                       block->set_space(dst_space);

  block = nullptr;

  auto  dst_blk = dst_space->get_block();

  superspace.insert_block(dst_blk);

  int  n = (superspace.get_side_length()/superspace.get_move_speed());

    switch(dir_id)
    {
      case(Dir::left):
        wake_upper();

        dst_blk->set_moving_counter(n);
        dst_blk->reset_functions({left_fn});
        break;
      case(Dir::right):
        wake_upper();

        dst_blk->set_moving_counter(n);
        dst_blk->reset_functions({right_fn});
        break;
      case(Dir::front):
        wake_upper();

        dst_blk->set_moving_counter(n);
        dst_blk->reset_functions({front_fn});
        break;
      case(Dir::back):
        wake_upper();

        dst_blk->set_moving_counter(n);
        dst_blk->reset_functions({back_fn});
        break;
      case(Dir::top):
        dst_blk->set_moving_counter(superspace.get_side_length()/(superspace.get_move_speed()>>1));
        dst_blk->reset_functions({top_fn});
        break;
      case(Dir::bottom):
        wake_upper();

        dst_blk->set_moving_counter(n);
        dst_blk->reset_functions({bottom_fn});
        break;
    }


  return true;
}


void
Space::
construct_block(bool  bubbly)
{
    if(!block || block->test_flag(Block::busy_flag))
    {
      return;
    } 


    if(start_move_block(Dir::top))
    {
      auto  blk = new Block(*this);

        if(bubbly)
        {
          blk->reset_bubble();
        }


      auto  bottom = get_link(Dir::bottom);

        if(bottom && bottom->get_block() && bottom->get_block()->test_bubbly())
        {
          blk->set_flag(Block::float_flag);
        }
    }
}



void
Space::
destruct_block()
{
    if(!block || block->test_flag(Block::busy_flag))
    {
      return;
    } 


  auto  bottom = links[(int)Dir::bottom];

    if(bottom)
    {
      auto  btmblk = bottom->get_block();

        if(btmblk)
        {
            if(!btmblk->test_flag(Block::hard_flag))
            {
              btmblk->set_flag(Block::deleteme_flag);

              superspace.insert_block(btmblk);
            }
        }

      else
        {
          start_move_block(Dir::bottom,0);
        }
    }
}




