#include"block.hpp"
#include"space.hpp"
#include"font.hpp"
#include"superspace.hpp"




namespace{


void
draw_color(Canvas::Drawer&  dr, const uint8_t*  rgba, int  x, int  y)
{
  enum{rgba8888 = 0xFFFFFFFF};

  dr.draw_formatted_ascii(rgba8888,x,y+(16*0),"R:%3d",rgba[0]);
  dr.draw_formatted_ascii(rgba8888,x,y+(16*1),"G:%3d",rgba[1]);
  dr.draw_formatted_ascii(rgba8888,x,y+(16*2),"B:%3d",rgba[2]);
  dr.draw_formatted_ascii(rgba8888,x,y+(16*3),"A:%3d",rgba[3]);
}


}


void
SuperSpace::
render_coloring()
{
  auto  dr = canvas.get_drawer();

  enum{
    w = (font_w*6),
    h = (font_h*6),
  };


    rep(y,3){
    rep(x,2){
      draw_color(dr,superblock->get_coloring().data[x|(y<<1)],w*x,h*y);
    }}


  dr.draw_rect(0xFFFFFFFF,w*color_point.x,h*color_point.y,w,h);

  superblock->draw(dr,w*2,0);

    if(test_flag(screenshot_flag))
    {
      save_screenshot(dr);

      unset_flag(screenshot_flag);
    }
}




bool
SuperSpace::
input_coloring(Controller&  ctrl)
{
  bool  flag = false;

    if(key_timer >= 10)
    {
           if(ctrl.test_pressing(Key::up_flag   )){if(color_point.y    ){  color_point.y--;  key_timer = 0;}}
      else if(ctrl.test_pressing(Key::left_flag )){if(color_point.x    ){  color_point.x--;  key_timer = 0;}}
      else if(ctrl.test_pressing(Key::right_flag)){if(color_point.x < 1){  color_point.x++;  key_timer = 0;}}
      else if(ctrl.test_pressing(Key::down_flag )){if(color_point.y < 2){  color_point.y++;  key_timer = 0;}}
      else if(ctrl.test_pressing(Key::other_flag))
        {
          auto  pid = (Block::PieceID)((color_point.y<<1)|color_point.x);
            switch(ctrl.other_key)
            {
              case(SDLK_q): superblock->up_color(pid,Block::COEL_r);break;
              case(SDLK_w): superblock->up_color(pid,Block::COEL_g);break;
              case(SDLK_e): superblock->up_color(pid,Block::COEL_b);break;
              case(SDLK_r): superblock->up_color(pid,Block::COEL_a);break;

              case(SDLK_a): superblock->down_color(pid,Block::COEL_r);break;
              case(SDLK_s): superblock->down_color(pid,Block::COEL_g);break;
              case(SDLK_d): superblock->down_color(pid,Block::COEL_b);break;
              case(SDLK_f): superblock->down_color(pid,Block::COEL_a);break;

            }


          key_timer = 0;

          superblock->update_shape(1<<pid);
        }


        if(!key_timer)
        {
          superblock->update_shape();

          flag = true;
        }
    }


  return flag;
}




