#include"block.hpp"
#include"space.hpp"
#include"superspace.hpp"




void
SuperSpace::
get_canvas_size(int&  w, int&  h, SDL_Point*  base_point, int  side_length, int  x_width, int  y_width, int  height)
{
  const int  side_length_half = (side_length/2);

  h = (side_length_half*((height*2)-2));

    if(base_point)
    {
      base_point->y = h;
    }


  w  = (side_length     *(x_width+y_width  ));
  h += (side_length_half*(x_width+y_width+2));

    if(base_point)
    {
      base_point->x = (w>>1);

        if(x_width < y_width){base_point->x += side_length_half*((y_width-x_width)-2);}
       else                  {base_point->x -= side_length_half*((x_width-y_width)+2);}
    }
}




void
SuperSpace::
make(const Parameter*  param)
{
    if(param && (&parameter != param))
    {
      parameter = *param;
    }


  x_width = (parameter.side_length*parameter.array_x_width);
  y_width = (parameter.side_length*parameter.array_y_width);
  height  = (parameter.side_length*parameter.array_height );

  array_slice_size = (parameter.array_x_width*
                      parameter.array_y_width);

  preview_point.x = 0;
  preview_point.y = 0;
  cursor_point.x  = 0;
  cursor_point.y  = 0;
  color_point.x   = 0;
  color_point.y   = 0;

  space_array.clear();

  delete_blocks_all();

  set_flag(resized_flag);

  superblock = nullptr;

    rep(z, parameter.array_height){
    rep(y,parameter.array_y_width){
    rep(x,parameter.array_x_width){
      space_array.emplace_back(*this,x,y,z);
    }}}


    rep(z,parameter.array_height){
    rep(y,parameter.array_y_width){
    rep(x,parameter.array_x_width){
      auto&  sp = get(x,y,z);

        if(z                              ){sp.set_link(Dir::bottom,&get(x  ,y  ,z-1));}
        if(z < (parameter.array_height -1)){sp.set_link(Dir::top   ,&get(x  ,y  ,z+1));}
        if(y                              ){sp.set_link(Dir::back  ,&get(x  ,y-1,z  ));}
        if(y < (parameter.array_y_width-1)){sp.set_link(Dir::front ,&get(x  ,y+1,z  ));}
        if(x                              ){sp.set_link(Dir::left  ,&get(x-1,y  ,z  ));}
        if(x < (parameter.array_x_width-1)){sp.set_link(Dir::right ,&get(x+1,y  ,z  ));}
    }}}


  set_flag(resized_flag);
  set_flag(updated_flag);


  view_rect.reset(0,std::min(x_width,parameter.side_length*parameter.scan_x_width),
                  0,std::min(y_width,parameter.side_length*parameter.scan_y_width),
                  0,std::min(height ,parameter.side_length*parameter.scan_height ));


  parameter.scan_x_width = (view_rect.x_width/parameter.side_length);
  parameter.scan_y_width = (view_rect.y_width/parameter.side_length);
  parameter.scan_height  = (view_rect.height /parameter.side_length);


  int  w;
  int  h;

  get_canvas_size(w,h,&base_point,
                  parameter.side_length,
                  parameter.scan_x_width,
                  parameter.scan_y_width,
                  parameter.scan_height);

  canvas.make_texture(std::max(w,256),
                      std::max(h,256));

  get_canvas_size(w,h,&preview_base_point,
                  parameter.side_length,
                  parameter.array_x_width,
                  parameter.array_y_width,
                  parameter.array_height);

  canvas.make_screen_buffer(w,h);


  auto&  sp = get(parameter.superblock_space_coord.x,
                  parameter.superblock_space_coord.y,
                  parameter.superblock_space_coord.z);

  auto  blk = new Block(sp);

  set_superblock(blk);
}




