#include"block.hpp"
#include"space.hpp"
#include"font.hpp"
#include"superspace.hpp"




void
SuperSpace::
render_preview()
{
    if(!mode_state)
    {
      visible_blocks.clear();

        rep(z,parameter.array_height ){
        rep(y,parameter.array_y_width){
        rep(x,parameter.array_x_width){
          auto  blk = get(x,y,z).get_block();

            if(blk && blk->test_flag(Block::visible_flag))
            {
              visible_blocks.push_back(blk);
            }
        }}}


      std::stable_sort(visible_blocks.begin(),visible_blocks.end(),&compare);

      auto  dr = canvas.get_screen_drawer();

      dr.fill_rect(0x00000000,0,0,dr.width,dr.height);

        for(auto  blk: visible_blocks)
        {
          blk->update(preview_base_point.x,preview_base_point.y);

          blk->draw(dr);
        }


      mode_state = 1;
    }


    if(test_flag(make_image_flag))
    {
      auto  dr = canvas.get_screen_drawer();

      webp_context.reset();

      webp_context.set_image(dr,0.5);

      webp_context.save("__IMAGE.webp");

      unset_flag(make_image_flag);
    }


  canvas.transfer(preview_point);

  auto  dr = canvas.get_drawer();

  const int         w = canvas.get_width();
  const int         h = canvas.get_height();
  const int  screen_w = canvas.get_screen_width();
  const int  screen_h = canvas.get_screen_height();

  dr.draw_formatted_ascii(0xFFFFFFFF,0,h-(font_h*2),"X: %4d/%4d",preview_point.x,screen_w);
  dr.draw_formatted_ascii(0xFFFFFFFF,0,h-(font_h*1),"Y: %4d/%4d",preview_point.y,screen_h);

    if(display_timer)
    {
      dr.draw_formatted_ascii(0xFFFFFFFF,0,0,"SAVED");
    }
}



bool
SuperSpace::
input_preview(Controller&  ctrl)
{
  bool  flag = false;

    if(ctrl.is_pressing_any())
    {
      const int         w = canvas.get_width();
      const int         h = canvas.get_height();
      const int  screen_w = canvas.get_screen_width();
      const int  screen_h = canvas.get_screen_height();

           if(ctrl.test_pressing(Key::up_flag   ) && ((preview_point.y    ) >=        4)){preview_point.y -= 4;}
      else if(ctrl.test_pressing(Key::down_flag ) && ((preview_point.y+4+h) <  screen_h)){preview_point.y += 4;}

           if(ctrl.test_pressing(Key::left_flag ) && ((preview_point.x    ) >=        4)){preview_point.x -= 4;}
      else if(ctrl.test_pressing(Key::right_flag) && ((preview_point.x+4+w) <  screen_w)){preview_point.x += 4;}

        if(ctrl.test_pressed(Key::start_flag))
        {
          set_flag(make_image_flag);

          display_timer = 10;
        }


      flag = true;
    }


  return flag;
}






