#ifndef THEORA_CONTEXT_HPP_INCLUDED
#define THEORA_CONTEXT_HPP_INCLUDED


#include"util.hpp"
#include<theora/theoraenc.h>
#include<ogg/ogg.h>
#include"canvas.hpp"


class
TheoraContext
{
  th_info	 info;

  th_enc_ctx*  ctx;

  th_comment  comment;

  th_img_plane  planes[3];

  ogg_stream_state  stream_state;
  ogg_packet              packet;
  ogg_page                  page;

  std::vector<uint8_t>  y_buffer;
  std::vector<uint8_t>  u_buffer;
  std::vector<uint8_t>  v_buffer;

  FILE*  file;

  void  write_packet();

public:
   TheoraContext();
  ~TheoraContext();


  void  open(int  width, int  height, const char*  path);

  void  push_frame(Canvas::Drawer&  dr, bool  last);

  void  close();

};


#endif




