#ifndef WEBP_CONTEXT_HPP_INCLUDED
#define WEBP_CONTEXT_HPP_INCLUDED


#include"util.hpp"
#include<webp/encode.h>
#include<webp/mux.h>
#include"canvas.hpp"


class
WEBP_Context
{
  WebPMux*  mux;

  void  encode(Canvas::Drawer&  dr, WebPData&  dat, float  quality);

public:
   WEBP_Context();
  ~WEBP_Context();


  void  reset();

  void  set_animation_parameters(uint8_t   r, uint8_t   g, uint8_t   b, uint8_t   a, int  loop_count=1);

  void  set_image(Canvas::Drawer&  dr, float  quality);

  void  push_frame(Canvas::Drawer&  dr, int  duration, float  quality);

  void  save(const char*  path);

};


#endif




